#define	HE86_EAX	0
#define	HE86_ECX	1
#define	HE86_EDX	2
#define	HE86_EBX	3
#define	HE86_ESP	4
#define	HE86_EBP	5
#define	HE86_ESI	6
#define	HE86_EDI	7
#define HE86_ES		0
#define HE86_CS		1
#define HE86_SS		2
#define HE86_DS		3
#define HE86_FS		4
#define HE86_GS		5

#define HE86_FLG_CF			0x00000001
#define HE86_FLG_PF			0x00000004
#define HE86_FLG_AF			0x00000010
#define HE86_FLG_ZF			0x00000040
#define HE86_FLG_SF			0x00000080
#define HE86_FLG_TF			0x00000100
#define HE86_FLG_IF			0x00000200
#define HE86_FLG_DF			0x00000400
#define HE86_FLG_OF			0x00000800
#define	HE86_FLG_NT			0x00004000
#define	HE86_FLG_RF			0x00010000
#define	HE86_FLG_VM			0x00020000

#define HE86_CR0_PE			0x00000001
#define HE86_CR0_PG			0x80000000

#define HE86_SFLG_IRQ		0x00000001
#define HE86_SFLG_NMI		0x00000002

#define HE86_SFLG_NMIMSK	0x00010000
#define HE86_SFLG_USE16C	0x00020000
#define HE86_SFLG_USE32C	0x00040000
#define HE86_SFLG_HALT		0x00080000
#define HE86_SFLG_USE16OPR	0x00100000
#define HE86_SFLG_USE32OPR	0x00200000
#define HE86_SFLG_USE16ADR	0x00400000
#define HE86_SFLG_USE32ADR	0x00800000
#define HE86_SFLG_USE16S	0x01000000
#define HE86_SFLG_USE32S	0x02000000

struct HE86_REGS {
	void *vp[4];	/* readmemȂǂ̊O֐RɎgĂ悢16oCg */
	unsigned int (*readmem)(struct HE86_REGS *r, unsigned int addr, unsigned int width);
	void (*writemem)(struct HE86_REGS *r, unsigned int addr, unsigned int width, unsigned int data);
	unsigned int (*readio)(struct HE86_REGS *r, unsigned int addr, unsigned int width);
	void (*writeio)(struct HE86_REGS *r, unsigned int addr, unsigned int width, unsigned int data);
	void (*irq)(struct HE86_REGS *r); /* PICƂ̌Mp */
	void (*panic)(struct HE86_REGS *r, char *msg); /* G[ȂǂŌĂяoAÎȂsetjmp/longjmp */
	int rsv0[7];
	int reg32[8], sreg[8], cr[8], dr[8], tr[8], rsv1[8 * 3];
	int segbase[8], seglimit[8], segflags[8], rsv2[8];
	unsigned int eip, eflags;
	int step, sysflags, defseg;
};

void he86_init_rm(struct HE86_REGS *r);
void he86_run(struct HE86_REGS *r);
void he86_loadsreg(struct HE86_REGS *r, int sreg_no, int sel, int flags); /* ʏflags0Ŏg */

void he86_int(struct HE86_REGS *r, int n);
int he86_fetch_code1(struct HE86_REGS *r);
int he86_fetch_code2(struct HE86_REGS *r);
void he86_push2(struct HE86_REGS *r, int i);
void he86_push4(struct HE86_REGS *r, int i);
int he86_pop2(struct HE86_REGS *r);
int he86_pop4(struct HE86_REGS *r);
unsigned int he86_read_regmem(struct HE86_REGS *r, int modrm, int width);
