#include "bootpack.h"
#include "he86.h"
#include <stdio.h>
#include <string.h>
#include <setjmp.h>

unsigned int readmem(struct HE86_REGS *r, unsigned int addr, unsigned int width)
{
	static unsigned char m7000[6] = {
		0xb8, 0x00, 0x90,			/* B8 9000			MOV		AX,0x9000	*/
		0x8e, 0xc0,					/* 8E C0			MOV		ES,AX		*/
		0xf4						/* F4				HLT					*/	/* he86_run()HLT߂łI */
	};
	int m0, m1;
	if (width == 2) {
		m0 = readmem(r, addr, 1);
		m1 = readmem(r, addr + 1, 1);
		return m0 | m1 << 8;
	}
	if (width == 4) {
		m0 = readmem(r, addr, 2);
		m1 = readmem(r, addr + 2, 2);
		return m0 | m1 << 16;
	}
	if (0x7000 <= addr && addr <= 0x7005) {
		return m7000[addr - 0x7000];
	}
	return 0x90; /* ͑̃͂ǂǂł0x90 */
}

void panic(struct HE86_REGS *r, char *msg)
{
	jmp_buf *pjb = r->vp[0];
	struct CONSOLE *cons = r->vp[1];
	cons_putstr0(cons, "panic: ");
	cons_putstr0(cons, msg);
	cons_putstr0(cons, "\n");
	longjmp(*pjb, 1);
}

void cmd_test_he86(struct CONSOLE *cons, char *cmdline)
{
	struct HE86_REGS r;
	int i;
	char s[40];
	jmp_buf jb;
	/* ȑݒ */
	r.readmem = &readmem;
	r.panic = &panic;
	r.vp[0] = &jb;
	r.vp[1] = cons;
	he86_init_rm(&r);
	for (i = 0; i < 6; i++) {	/* ES, CS, SS, DS, ES, FS, GS */
		he86_loadsreg(&r, i, 0x0000, 0);
	}
	for (i = 0; i < 8; i++) {
		r.reg32[i] = 0;
	}
	r.eip = 0x7000; /* 0000:7000 Ɏp̃R[huƂɂ */
	r.reg32[HE86_ESP] = 0x7c00;
	r.step = 0x7fffffff; /* قږ */
	if (setjmp(jb) == 0) {
		he86_run(&r);
		/* HLT߂sƂɗ */
	} else {
		/* panic()֐longjmp()ĂяoƂɂ */
		/* Ƃ肠Ȃ */
	}
	sprintf(s, "eip=%04X\n", r.eip);
	cons_putstr0(cons, s);
//	cons_newline(cons);
	return;
}

